using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TargetController.Common;
using VirtuosoComponentLibrary;
using CuriosityBoardLibrary;

namespace KnobAnalogInput_Host
{
	public class KnobAnalogInput_TargetViewModel : KnobAnalogInput_TargetModel
	{
		public KnobAnalogInput_TargetViewModel()
		{
			InitializeComponents();
		}

		public KnobAnalogInput_TargetViewModel (ITargetHostingConfiguration TargetConfiguration) : base(TargetConfiguration)
		{
			InitializeComponents();
		}

		private void InitializeComponents()
		{
			// Add component(s) here....
			_PowerButton = new PowerButtonViewModel(this, "VirtualDeviceIsPowered", LEDTileImage.Tile1, PowerButtonColor.Blue);
            // Initialize the mechanically limited Knobs Control View Model. It will bind to SIM_Knob variable in target
            _KNOBVM1 = new KnobControlViewModel(this, "SIM_Knob", 0, 1023, 270, 120);
            // Initialize the mechanically unlimited Knobs Control View Model. It will bind to SIM_Knob variable in target
            _KNOBVM2 = new KnobControlViewModel(this,"SIM_Knob", 180);
		}

		private PowerButtonViewModel _PowerButton;
		public PowerButtonViewModel PowerButton
		{
			get
			{
				return _PowerButton;
			}
		}

        private KnobControlViewModel _KNOBVM1;
        public KnobControlViewModel KNOBVM1
        {
            get
            {
                return _KNOBVM1;
            }
        }

        private KnobControlViewModel _KNOBVM2;
        public KnobControlViewModel KNOBVM2
        {
            get
            {
                return _KNOBVM2;
            }
        }
	}
}
